Subject: Re: bug#16380: Failing tests on Solaris in 2.16

From: Paul Eggert <[email-masked]>
Date: Tue, 07 Jan 2014 21:49:31 -0800

And Jim pointed out a bug in that patch, so I pushed the following
further patch into grep (with the init.sh part pushed to gnulib).

 From 79b186f715b3a7a4622a3b90aa30b0c62de0549a Mon Sep 17 00:00:00 2001
From: Paul Eggert <[email-masked]>
Date: Tue, 7 Jan 2014 21:47:04 -0800
Subject: [PATCH] tests: port Solaris 10 /bin/sh patch back to GNU/Linux

Problem reported by Jim Meyering.
* tests/bre, tests/ere, tests/spencer1-locale:
Prefer re_shell, not re_shell_.
* tests/init.sh (re_shell): New var, which is exported instead of
re_shell_.
---
  tests/bre             | 2 +-
  tests/ere             | 2 +-
  tests/init.sh         | 3 ++-
  tests/spencer1-locale | 2 +-
  4 files changed, 5 insertions(+), 4 deletions(-)

diff --git a/tests/bre b/tests/bre
index 4a00af4..4c0eb13 100755
--- a/tests/bre
+++ b/tests/bre
@@ -16,6 +16,6 @@ fail=0
  ${AWK-awk} -f $abs_top_srcdir/tests/bre.awk $abs_top_srcdir/tests/bre.tests \
      > bre.script || fail=1
  
-${re_shell_-${SHELL-sh}} ./bre.script || fail=1
+${re_shell-${SHELL-sh}} ./bre.script || fail=1
  
  Exit $fail
diff --git a/tests/ere b/tests/ere
index 03aec36..6ad7982 100755
--- a/tests/ere
+++ b/tests/ere
@@ -16,6 +16,6 @@ fail=0
  ${AWK-awk} -f $abs_top_srcdir/tests/ere.awk $abs_top_srcdir/tests/ere.tests \
    > ere.script || fail=1
  
-${re_shell_-${SHELL-sh}} ere.script || fail=1
+${re_shell-${SHELL-sh}} ere.script || fail=1
  
  Exit $fail
diff --git a/tests/init.sh b/tests/init.sh
index e07c39c..fbd293d 100644
--- a/tests/init.sh
+++ b/tests/init.sh
@@ -201,7 +201,8 @@ else
        *x*) opts_=-x ;;
        *) opts_= ;;
      esac
-    export re_shell_
+    re_shell=$re_shell_
+    export re_shell
      exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
      echo "$ME_: exec failed" 1>&2
      exit 127
diff --git a/tests/spencer1-locale b/tests/spencer1-locale
index 6484490..e8deeac 100755
--- a/tests/spencer1-locale
+++ b/tests/spencer1-locale
@@ -18,6 +18,6 @@ ${AWK-awk} -v extra_locale=$LOCALE_FR_UTF8 \
      -f "$abs_srcdir/spencer1-locale.awk" "$abs_srcdir/spencer1.tests" \
    > spencer1-locale.script || fail=1
  
-${re_shell_-${SHELL-sh}} spencer1-locale.script || fail=1
+${re_shell-${SHELL-sh}} spencer1-locale.script || fail=1
  
  Exit $fail
-- 
1.8.3.1